package com.fdkankan.ucenter.typehandle;

import com.alibaba.fastjson.JSONArray;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.type.BaseTypeHandler;
import org.apache.ibatis.type.JdbcType;
import org.apache.ibatis.type.MappedJdbcTypes;
import org.apache.ibatis.type.MappedTypes;

import java.sql.CallableStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 *  存储到数据库, 将JSON数组对象转换成字符串;
 *  从数据库获取数据, 将字符串转为JSON数组对象.
 */
@MappedTypes({JSONArray.class})
@MappedJdbcTypes({JdbcType.VARCHAR})
public class JsonArrayTypeHandler extends BaseTypeHandler<JSONArray> {
    @Override
    public void setNonNullParameter(PreparedStatement ps, int i, JSONArray parameter,
                                    JdbcType jdbcType) throws SQLException {
        ps.setString(i, JSONArray.toJSONString(parameter));
    }
    @Override
    public JSONArray getNullableResult(ResultSet rs, String columnName)
            throws SQLException {
        return parseArray(rs.getString(columnName));
    }
    @Override
    public JSONArray getNullableResult(ResultSet rs, int columnIndex) throws SQLException {
        return parseArray(rs.getString(columnIndex));
    }
    @Override
    public JSONArray getNullableResult(CallableStatement cs, int columnIndex)
            throws SQLException {
        return parseArray(cs.getString(columnIndex));
    }

    public static JSONArray parseArray(String content) {
        if(StringUtils.isBlank(content)){
            return new JSONArray();
        }
        try {
            return JSONArray.parseArray(content);
        } catch (Exception e) {
            return new JSONArray();
        }
    }

}

